<template>
  <v-card
    :disabled="loading"
    :loading="loading"
    class="mx-auto my-12"
    max-width="374"
  >
    <template v-slot:loader="{ isActive }">
      <v-progress-linear
        :active="isActive"
        color="primary"
        height="4"
        indeterminate
      ></v-progress-linear>
    </template>

    <v-card-item>
      <LanguageSwitch :languages="[]" />
    </v-card-item>

    <v-card-item>
      <LogoImage />
    </v-card-item>

    <v-card-item>
      <v-card-text>
        <div class="space-y-4">
          <v-form ref="form" @submit.prevent="login()">
            <v-row
              align="center"
              class="mx-0"
            >
              <v-text-field
                v-model="email"
                id="email"
                :rules="validator.setRules('required|email').validate()"
                :placeholder="translate('placeholders.email')"
                validate-on="submit"
              ></v-text-field>
            </v-row>
            <v-row
              align="center"
              class="mx-0"
            >
              <v-text-field
                v-model="password"
                id="password"
                :placeholder="translate('placeholders.password')"
                :rules="validator.setRules('required|min:5').validate()"
                :append-inner-icon="show ? 'mdi-eye-outline' : 'mdi-eye-off-outline'"
                :type="show ? 'text' : 'password'"
                @click:append-inner="show = !show"
                v-on:keyup.enter="login"
                maxlength="30"
                validate-on="submit"
              ></v-text-field>
            </v-row>
          </v-form>
        </div>

        <div class="d-flex justify-end">
          <pretty-link :to="{ name: 'authentication.forgot-password', query: email ? { email } : {},}">
            <template #title>
              {{ translate('links.forgot_password') }}
            </template>
          </pretty-link>
        </div>

      </v-card-text>
    </v-card-item>

    <v-card-actions>
      <button-submit
        :action="login"
        :loading="loading"
      >
        <template #label>
          {{ translate('buttons.login') }}
        </template>
      </button-submit>

    </v-card-actions>
  </v-card>

</template>

<script lang="ts" setup>
import { ref } from 'vue'
import { useRouter } from 'vue-router'
import { useI18n } from 'vue-i18n'
import { storeFactory } from '@/main'

// Components
import LanguageSwitch from '@/components/language/LanguageSwitch.vue'
import LogoImage from '@/components/LogoImage.vue'

//Validator
import { Validator } from '@/helpers/Validator'
import PrettyLink from '@/components/link/PrettyLink.vue'
import ButtonSubmit from '@/components/button/ButtonSubmit.vue'

const { t: translate } = useI18n()

const userStore = storeFactory.userStore
const toastStore = storeFactory.toastStore

const router = useRouter()
const form = ref(null) as any
const email = ref('')
const password: any = ref('')
const show = ref(false)
const validator = new Validator()

const loading = ref(false)
const setLoader = (v: any) => (loading.value = v)

const login = async () => {
  setLoader(true)
  if (!(await form.value.validate())?.valid) {
    setLoader(false)
    return
  }

  console.log('try login', userStore, toastStore)
  if (await userStore.login(email.value, password.value)) {

    // TODO: temp
    //if (await userStore.isActivated(email.value)) {
    if (true) {

      console.log('try redirect')
      await router.push({ name: 'dashboard.index' }).then(() => {
        toastStore.success(
          translate('labels.success'),
          translate('login.successfully_logged_in')
        )
      })
    } else {
      toastStore.danger(
        translate('labels.error'),
        translate('validation.the_login_details_were_incorrect') +
        '. ' +
        translate('validation.please_try_again') +
        '.'
      )
      setLoader(false)
      await userStore.logout()
    }
  }
}
</script>
